// SPDX-License-Identifier: GPL-3.0
//
// Copyright (C) 2019, Donald Dugger
//
import * as C from "../common/constants.js";
import { logger } from "../common/utils";
import { cities } from "../common/cities"
import { countries } from "../common/countries"

let local = { name: "Local", tz: 0 };
let none = { name: "None", tz: C.TZ_NONE };
let custom1 = { name: "Custom 1", tz: 32 };
let custom2 = { name: "Custom 2", tz: 33 };

let Tiles1 = [];
let Tiles2 = [];

export function new_delegate()
{

  for (var idx in Tiles1)
    set_tile(Tiles1[idx], null);
  Tiles1 = [];

  for (var idx in Tiles2)
    set_tile(Tiles2[idx], null);
  Tiles2 = [];
}
export function get_idx(cfg, index)
{

  let idx = index - 2;
  if ((cfg == C.SCR_CFG1) && (idx < 0))
    idx -= 2;
  return idx;
}

export function get_info(idx)
{
  switch (idx) {

  case -4:
    return local;

  case -3:
    return custom1;

  case -2:
    return none;

  case -1:
    return custom2;

  default:
    if (idx < cities.length)
      return cities[idx];
    else
      return countries[idx - cities.length];

  }
}

export function set_tile(idx, tile)
{

  switch (idx) {

  case -4:
    local.tile = tile;
    break;

  case -3:
    custom1.tile = tile;
    break;

  case -2:
    none.tile = tile;
    break;

  case -1:
    custom2.tile = tile;
    break;

  default:
    if (idx < cities.length)
      cities[idx].tile = tile;
    else
      countries[idx - cities.length].tile = tile;

  }
}

export function num_cities()
{

  return cities.length;
}

export function num_countries()
{

  return countries.length;
}

export function get_index(cfg, name)
{

  return (cfg == C.SCR_CFG1) ? Tiles1[name] : Tiles2[name];
}

export function set_index(cfg, name, idx)
{

  if (cfg == C.SCR_CFG1)
    Tiles1[name] = idx;
  else
    Tiles2[name] = idx;
}
